{#
/**
 * @file
 * Theme override for a Nav component.
 *
 * Available config:
 * - alignment: left | right | center | vertical.
 * - style: tabs | pills
 * - fill: fill | justify
 * - nav_utility_classes: An array of utility classes.
*
 * Changes against Radix:
 * - TODO
 */
#}

{# Changes to the Radix implementation:
  - Add data-bs-display="static" if the nav is vertical (+ add the alignment_classes differently)
  - Use our drowl_base:nav-item-link SDC to render menu links
  - Add support for our megamenu implementation
#}
{% set nav_utility_classes = nav_utility_classes ? nav_utility_classes : [] %}
{# Pre-loop the items, to figure out if we have megamenus #}
{% set has_megamenu = false %}
{% for item in items %}
  {% if item.content.field_paragraphs.0 %}
    {% set has_megamenu = true %}
  {% endif %}
{% endfor %}

{% import _self as menus %}

{% set alignment_classes = {
  'right': 'justify-content-end',
  'center': 'justify-content-center',
  'vertical': 'flex-column',
  'left': ''
} %}

{% set style = style ? 'nav-' ~ style : '' %}
{% set fill = fill ? 'nav-' ~ fill : '' %}

{%
  set nav_classes = [
    'nav',
    is_megamenu and (not hide_megamenus) ? 'nav--has-megamenu',
    style,
    alignment_classes[alignment] ?? '',
    fill
  ]|merge(nav_utility_classes )
%}

{% if darkmode %}
  {% set attributes = attributes.setAttribute('data-bs-theme', 'dark') %}
{% endif %}

{% if items %}
  <ul{{ attributes.addClass(nav_classes) }}>
    {% block nav_items %}
      {% for item in items %}
        {% set nav_link_classes = [] %}
        {% set has_submenu = item.is_expanded and item.below %}
        {% set is_megamenu = item.content.field_paragraphs.0 ? true : false %}
        {% set nav_item_classes = [
          'nav-item',
          item.original_link.entity ? 'nav-item-entity-id--' ~ item.original_link.entity.id() : '',
          item.in_active_trail ? 'active' : '',
          has_submenu ? 'dropdown' : '',
          is_megamenu and (not hide_megamenus) ? 'nav-item--mega-menu',
        ]|merge(nav_item_utility_classes ?: []) %}
        {% if item.url.options.attributes.class is iterable %}
          {% set nav_link_classes = nav_link_classes|merge(item.url.options.attributes.class) %}
        {% elseif item.url.options.attributes.class %}
          {% set nav_link_classes = nav_link_classes|merge([item.url.options.attributes.class]) %}
        {% endif %}
        {% if nav_link_utility_classes  %}
          {% set nav_link_classes = nav_link_classes|merge(nav_link_utility_classes) %}
        {% endif %}
        <li{{ item.attributes.addClass(nav_item_classes) }}>
          {% include 'drowl_base:nav-item-link' with {
            menu_item: item,
            is_active: item.in_active_trail,
            is_nav_link: true,
            is_hover_nav: is_hover_nav ?: false,
            is_dropdown_toggle: has_submenu,
            is_dropdown_toggle_static: alignment == 'vertical' or (is_megamenu and (not hide_megamenus)),
            nav_item_link_utility_classes: nav_link_classes,
            icon_name_class: item.entity.field_icon.0 ? item.entity.field_icon.value : '',
            icon_position: item.entity.field_icon_position.0 ? item.entity.field_icon_position.value : 'icon_position_left',
          } %}
          {% if is_megamenu and (not hide_megamenus) %}
            {% include 'drowl_base:megamenu-dropdown' with {
              submenu: has_submenu ? item.below,
              submenu_position: item.entity.field_megamenu_submenu_position.value|default('bottom'),
              megamenu_content: item.content.field_paragraphs|field_value
            } %}
          {% elseif has_submenu %}
            {% include 'radix:dropdown-menu' with {
              items: item.below,
              direction: dropdown_direction|default('dropdown'),
              overview_link: alignment == 'vertical' ? item|without('below') : [],
              is_dropdown_toggle_static: alignment == 'vertical' or (is_megamenu and (not hide_megamenus)),
              is_hover_nav: is_hover_nav ?: false,
              menu_utility_classes: expand_active_trail and item.in_active_trail ? ['show'] : [],
            } %}
          {% endif %}
        </li>
      {% endfor %}
    {% endblock nav_items %}
  </ul>
{% endif %}
